package com.ggstudios.divisionbyzero;

class StatBar extends Drawable {

	public float x, y, w, h;
	private float max, val;
	private float percent;
	
	private Rectangle bg, fill;
	
	public StatBar(float x, float y, float w, float h) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		
		build();
	}
	
	private void build() {
		bg = new Rectangle(x, y, w, h, 0xFF505050);
		fill = new Rectangle(x, y, w, h, 0xFFFFFFFF);
	}
	
	private void recalculatePercent() {
		percent = val / max;
		
		if(percent > 1f) percent = 1f;
		
		fill.setScaleWidth(percent);
	}
	
	public void setMaxValue(float max) {
		this.max = max;
		recalculatePercent();
	}
	
	public void setValue(float val) {
		this.val = val;
		recalculatePercent();
	}
	
	@Override
	public void draw(float offX, float offY) {
		bg.draw(offX, offY);
		fill.draw(offX, offY);
	}

	@Override
	public void refresh() {
		bg.refresh();
		fill.refresh();
	}
}
